
num_tasks = length(X);

errors_tr = zeros(3,length(gammas));

N_tr = N;

% Loop on tasks
for v = 1:num_tasks
    % We'll hold out one from this task, reducing its num samples:
    N_tr(v) = N_tr(v) - 1;
    num_samples_this_task = length(X{v});
    if (num_samples_this_task >= 2)
        
        
        for held_out = 1:num_samples_this_task
            clear X_tr;
            clear held_out_sample;
            X_tr = X;
            X_tr{v} = [X{v}(1:(held_out - 1)) X{v}(num_samples_this_task:-1:(held_out + 1))];
            held_out_sample = X{v}(held_out);
            
            % getting stats for the training data
            [mu_st_tr,s_st_tr,~,s_pool_tr] = get_st_and_pooled_stats(X_tr);
            
            if pool_flag == 1 % using pooled if flag is on
                s_st_tr = s_pool_tr;
            end
            
            % trying all the parameter-dependent estimators
            held_out_err = zeros(3, length(gammas));
            for k = 1:length(gammas)
                % estimated pairwise optimal A
                mu_const_tr = MTA_constant(mu_st_tr', s_st_tr, N_tr, 'mean', gammas(k)); % constant A
                
                % estimated constant A
                mu_minimax_tr = MTA_constant(mu_st_tr', s_st_tr, N_tr,'minimax', gammas(k)); % constant A
                
                % average of means regularization
                mu_am_tr = lambdas(k)*mu_st_tr + (1-lambdas(k))*mean(mu_st_tr);
                
                
                held_out_err(1,k) = held_out_err(1,k) + errors(held_out_sample, mu_const_tr(v));
                held_out_err(2,k) = held_out_err(2,k) + errors(held_out_sample, mu_minimax_tr(v));
                held_out_err(3,k) = held_out_err(3,k) + errors(held_out_sample, mu_am_tr(v));
            end % End loop on cv parameter choices
        end % End loop on held-out samples for this task
        
        task_mean_held_out_error = held_out_err / num_samples_this_task;
        
        errors_tr = errors_tr + task_mean_held_out_error;
        
        N_tr(v) = N_tr(v) + 1; % Revert num_samples to original state
    end % if there are at least 2 samples so we can hold something out
end % loop on tasks
errors_tr = errors_tr / num_tasks;

% best params
[~,opt_param_inds] = min(errors_tr');

params_opt = [gammas(opt_param_inds(1)) gammas(opt_param_inds(2))...
    lambdas(opt_param_inds(3)) ];

% standard suite of various convex combinations with best params
[mu_const_CV,mu_minimax_CV,mu_am_CV] = run_MTA_suite_CV(mu_st',s_st',N,params_opt);
