function [e,s] = errors(x,z,type)

% type == 0 -> classification percent error
% type == 1 -> mean absolute error
% type == 2 -> MSE

if nargin == 2
    type = 2;
end

[r1,c1] = size(x);
[r2,c2] = size(z);

% rotating to standard orientation
if c1 == c2 && r1 ~= r2
    x = x';
    z = z';
    [~,c1] = size(x);
    [~,c2] = size(z);
end 

if type == 2
    e = mean( (repmat(x,1,c2) - repmat(z,1,c1)).^2 ); 
    s = var( (repmat(x,1,c2) - repmat(z,1,c1)).^2 ); 
elseif type == 1
    e = mean( abs(repmat(x,1,c2) - repmat(z,1,c1)) );
    s = var( abs(repmat(x,1,c2) - repmat(z,1,c1)) );
elseif type == 0
    e = 100*mean( repmat(x,1,c2) ~= repmat(z,1,c1) );
    s =  100*var( repmat(x,1,c2) ~= repmat(z,1,c1) );
end

