function [mu_st,s_st,mu_pool,s_pool] = get_st_and_pooled_stats(X)

if ~iscell(X) % if one task, gotta make it a cell
    X = {X};
end

T = length(X); % number of tasks

N = cellfun(@length,X); % number of samples per tasks

%% getting means and pooled means
sums = cellfun(@sum,X); % sums of samples pers task

mu_st = sums./N; % means

sum_N = sum(N); % total number of samples across all tasks

if nargout > 2
    mu_pool = sum(sums)./sum_N; % pooled mean
    mu_pool = repmat(mu_pool,T,1); % made into a vector
end

%% getting variances and pooled variances
sum_of_sq = cellfun(@(x) sum(x.^2),X); % sum of squared samples
sq_of_sums = sums.^2 ; % square of sums
diff = sum_of_sq - sq_of_sums./N; % difference 

s_st = diff ./ (N - 1);  % variances
s_st(N < 2) = 0; % replacing NaNs with 0

if nargout > 3
    num_non_zero_tasks = sum(N > 0); % if N = 0 samples, doesn't count as a task
    s_pool = sum( diff ) ./ ( sum_N - num_non_zero_tasks );  % pooled variance
    s_pool = repmat(s_pool,T,1); 
end