clear all

%% load data
load ('kings.mat');
X = kings;


%% parameters
pool_flag = 1;
i = 1; % dummy dataset index
gammas = 2.^(-15:1:15);
lambdas = gammas./(gammas+1); % if gamma = lambda/(1-lambda), then lambda = gamma/(1+gamma)


num_estimators = 8; % We compare 8 different estimators.

sum_task_mse = zeros(num_estimators, 1);
num_tasks = length(X);
for u = 1:num_tasks
    N(u) = length(X{u});
end


%% single-task estimates
[mu_st, s_st, mu_one, s_pool] = get_st_and_pooled_stats(X);
if pool_flag == 1;
    s_st = repmat(s_pool, size(s_st));
end


%% MTA estimates
[mu_js, mu_const, mu_minimax] = run_MTA_suite(mu_st', s_st', N');

%% MTA CV estimates
% standard suite of various convex combinations with best params
do_MTA_CV_LOOCV


estimates(1,:) = mu_st;
estimates(2,:) = mu_one;
estimates(3,:) = mu_js;
estimates(4,:) = mu_am_CV;
estimates(5,:) = mu_const;
estimates(6,:) = mu_const_CV;
estimates(7,:) = mu_minimax;
estimates(8,:) = mu_minimax_CV;


'Here is latex for data in Feldman 2014 table - load kings_names for correct ordering of dynasty.'
latex(estimates')

