function [mu_const, mu_minimax, mu_am, mu_pair, mu_pl] = ...
            run_MTA_suite_CV(mu_st,s_st,N,params)

        
% estimated pairwise optimal A and estimated constant A
mu_const = MTA_constant(mu_st,s_st,N,'mean',params(1)); % constant A

mu_minimax = MTA_constant(mu_st,s_st,N,'minimax',params(2)); % constant A

% average of means regularization
mu_am = params(3)*mu_st + (1-params(3))*mean(mu_st);

if nargout > 3
    % pairwise MTA
    mu_pair = MTA_pairwise(mu_st,s_st,N,params(4)); % pairwise A

    % regularizing towards pooled mean and average of means (AOM)
    mu_pl = params(5)*mu_st + (1-params(5))*(N'*mu_st)/sum(N);
end
